Attribute VB_Name = "dde_connection"
'  Demonstration Program to explain the
'  TimeWatcher DDE Interface
' --------------------------------------------------------------------
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' --------------------------------------------------------------------
'  Visit: www.timewatcher.de
' --------------------------------------------------------------------


Option Explicit

Const DDE_SERVER_APP = "TimeWatcher"
Const DDE_SERVER_FROM = "tiwa"
Const NUM_LINKBOXES = 7

Dim link_item_list() As String

Public Function connect_to_dde_server() As Integer
' Fuction to link the lables to the corresponding controls in the
' TimeWatcher applications and thereby initialize the DDE
' communictaion

Dim i As Integer
On Error GoTo ErrHandler
Call set_link_item_list
  
For i = 0 To NUM_LINKBOXES - 1
 With DDE_Monitor.Label_Linked(i)
  .LinkMode = 0
  .LinkTopic = DDE_SERVER_APP & "|" & DDE_SERVER_FROM
  .LinkItem = link_item_list(i)
  .LinkMode = 1
 End With
Next

connect_to_dde_server = 0

Exit Function

ErrHandler:

If Err.Number = 282 Then
' Could not link to the controls, probalby TimeWatcher is not running
 connect_to_dde_server = -1
Else
' Some other error
 connect_to_dde_server = -2
End If

End Function

Public Sub disconnect_from_dde_server()
' Disable the DDE connection to the TimeWatcher application
Dim i As Integer
For i = 0 To NUM_LINKBOXES - 1
 DDE_Monitor.Label_Linked(i).LinkMode = 0
Next
End Sub

Public Sub record_action(action As Integer, employee As String, long_arg As Long, double_arg As Double, text1_arg As String, text2_arg As String)
' Function to create a text for the different actions
Dim list_text As String
Select Case action
Case 1
 list_text = "NM '" & text2_arg & "' recharged with " & CStr(long_arg) & " seconds"
Case 2
 list_text = "NM '" & text2_arg & "' accout removed with " & CStr(long_arg) & " seconds remaining"
Case 3
 list_text = "NM '" & text2_arg & "' accout set to zero with " & CStr(long_arg) & " seconds remaining"
Case 4
 list_text = "NM '" & text2_arg & "' notes changed to '" & text1_arg & "'"
Case 5
 list_text = "NM '" & text2_arg & "' finshed session after " & CStr(long_arg) & " seconds"
Case 6
 list_text = "NM '" & text2_arg & "' account created"
Case 7
 list_text = "NM '" & text2_arg & "' password was changed"
Case 13
 list_text = "NM '" & text2_arg & "' logged in with " & CStr(long_arg) & " seconds remaining"
Case 8
 list_text = CStr(long_arg) & " seconds were added to computer " & text1_arg & " running in countdown mode"
Case 9
 list_text = "Timer Countdown with " & CStr(long_arg) & " seconds was started on computer " & text1_arg
Case 10
 list_text = "Timer Countup was stopped on computer " & text1_arg & " after " & CStr(long_arg) & " seconds"
Case 11
 list_text = "Timer Countup was started on computer " & text1_arg
Case 12
 list_text = "Timer Countdown was stopped on computer " & text1_arg
Case 14
 list_text = "Employee Login"
Case 15
 list_text = "Employee Logout"
Case 16
 list_text = "Employee did a Screencapture of a client"
Case 17
 list_text = "Employee changed his security formula"
Case 18
 list_text = "Employee changed his password"
End Select
list_text = CStr(Time) & ": " & list_text & " (Emloyee: " & employee & " - Cost: " & Format(double_arg, "Currency") & ")"
Call DDE_Monitor.update_action_list(list_text)
End Sub

Private Sub set_link_item_list()
' Function for fill the link_item_list array with the names of the
' DDE controls in the TimeWatcher application
ReDim link_item_list(NUM_LINKBOXES)
link_item_list(0) = "dde_counter"
link_item_list(1) = "dde_action"
link_item_list(2) = "dde_empl"
link_item_list(3) = "dde_long"
link_item_list(4) = "dde_double"
link_item_list(5) = "dde_text"
link_item_list(6) = "dde_text2"
End Sub
